// must include WINDOWS.H before this
class GroupFile{
    char *grpfil;
    HFILE hf;
    int opened,items_to_read,error_condition_exists,tag_bytes;
    int got_icon_default_data,x_pixels,y_pixels,icon_planes,icon_pixelbits;
    int __far *pItemOffset;
    HGLOBAL memhandle,memhandle2;
    LONG filebytes;
    void __far *memptr; // entire .GRP file
    void __far *memptr2; // ptrs to strings, strings
    // helper function prototypes...
    int second_lower(unsigned int first,unsigned int second);
    void get_icon_default_data();
public:
    GroupFile(char *p=NULL);
    ~GroupFile();
    void set_filename(char *p);
    int error(){return error_condition_exists;}
    int openfile();
    void readheader();
    int itemsleft(){return items_to_read;}
    int showitem(int offset);
    char __far *get_group_name();
    char __far *get_item_name(int offset);
    char __far *get_item_command(int offset);
    char __far *get_item_command_nopath(int offset);
    char __far *get_item_parameters(int offset);
    char __far *get_item_default_dir(int offset);
    int is_item_iconized(int offset);
    HBITMAP get_fill_item_and_bitmap(int offset,int&x,int&y);
    HBITMAP get_fill_item_xor_bitmap(int offset,int&x,int&y);
    int get_icon_dimensions(int& height,int& width);
    UINT get_icon_planes();
    UINT get_icon_pixelbits();
    void done_with_bitmaps();
};
